﻿
using MySqlX.XDevAPI.Common;
using OASystem.Domain.Dtos;
using OASystem.Domain.Entities.System;
using OASystem.Domain.ViewModels.System;
using OASystem.Infrastructure.Repositories.Login;
using OASystem.Infrastructure.Repositories.System;

namespace OASystem.API.Controllers
{
    /// <summary>
    /// 系统设置
    /// </summary>
    [Route("api/[controller]/[action]")]
    public class SystemController : ControllerBase
    {
        private readonly DepartmentRepository _sysDepRep;
        private readonly UsersRepository _userRep;
        private readonly IMapper _mapper;

        public SystemController(DepartmentRepository sysDepRep, IMapper mapper, UsersRepository userRep)
        {
            _sysDepRep = sysDepRep;
            _userRep = userRep;
            _mapper = mapper;
        }

        #region user 操作

        [Authorize]
        [HttpGet]
        [ProducesResponseType(typeof(LoginView), StatusCodes.Status200OK)]
        public async Task<IActionResult> GetUserList()
        {
           var userList = _userRep.GetUserList(_userRep);
            
            if (userList.Result.Code != 0)
            {
                return Ok(JsonView(false, userList.Result.Msg));
            }
            
            return Ok(JsonView(userList.Result.Data));
        }

        #endregion
        //[Authorize]
        [HttpPost]
        [ProducesResponseType(typeof(LoginView), StatusCodes.Status200OK)]
        public async Task<IActionResult> fnQueryDepartment(Sys_DepartmentDto dto)
        {
            _sysDepRep.BeginTran();
            var result = _sysDepRep.QueryDto<Sys_Department,DepartmentView>(s => s.CompanyId == dto.CompanyId).ToList();
            foreach (var item in result)
            {
                item.a = "123";
            }
            //string sql = "select * from Sys_Department where CompanyId='2'";
            //var result2 = _sysDepRep.GetListBySqlWithNolock(sql);
            //List<Sys_DepartmentView> dep = _mapper.Map<List<Sys_DepartmentView>>(result2);
           
            return Ok(JsonView(0, "调用完成:", result));
        }
    }
}
